﻿//////////////////////////////////////////////
// CameraManagerWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT CameraManagerWrapper final
	{
		private :

			// Constructeur, destructeur
			CameraManagerWrapper () = delete ;
			~CameraManagerWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Management
			static nkScripts::OutputValue createOrRetrieve (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue erase (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue rename (const nkScripts::DataStack& stack) ;
			// Getters
			static nkScripts::OutputValue getActiveRenderCam (const nkScripts::DataStack& stack) ;
	} ;
}