﻿//////////////////////////////////////////////
// ShaderResourceDesc.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class ConstantBuffer ;
	class Sampler ;
	class ShaderResource ;
}

/// Class ------------------------------------

namespace nkGraphics
{
	// Description d'une resource bindée à un shader
	template<typename T>
	class ShaderBoundResourceDesc
	{
		public :

			// Attributes
			unsigned int _slot ;
			unsigned int _space ;

			T* _resource ;

		public :
			
			// Constructeur, destructeur
			ShaderBoundResourceDesc () = default ;

			ShaderBoundResourceDesc (unsigned int slot, unsigned int space, T* resource)
			:	_slot (slot),
				_space (space),
				_resource (resource)
			{
				// Nothing to do
			}

			~ShaderBoundResourceDesc () = default ;
	} ;

	// Typedefs des usages
	using ConstantBufferResourceDesc = ShaderBoundResourceDesc<ConstantBuffer> ;
	using ShaderResourceDesc = ShaderBoundResourceDesc<ShaderResource> ;
	using UavResourceDesc = ShaderBoundResourceDesc<Buffer> ;
	using SamplerResourceDesc = ShaderBoundResourceDesc<Sampler> ;
}